<template>
  <div>
    <Navbar/>
    <b-container>
      <b-row>
        <b-col>
          <b-table
            :items="users"
            :fields="fields"
            :sort-by.sync="sortBy"
            :sort-desc.sync="sortDesc"
            sort-icon-left
            responsive="sm"
          >
            <template v-slot:cell(actions)="row">
              <b-button
                size="sm"
                @click="row.toggleDetails"
              >{{ row.detailsShowing ? 'Hide' : 'Show' }} Leaves</b-button>
            </template>

             <template v-slot:row-details="row">
              <b-card>
                <b-table
                  :items="row.item.leaves"
                  :fields="leave_fields"
                  :sort-by.sync="sortBy"
                  :sort-desc.sync="sortDesc"
                  sort-icon-left
                  responsive="sm"
                >
                  <template v-slot:cell(actions)="row">
                    <b-dropdown size="sm" id="dropdown-1" text="Actions">
                      <b-dropdown-item @click="update_leave(row.item.uuid, 'ACCEPTED')">Accept</b-dropdown-item>
                      <b-dropdown-item @click="update_leave(row.item.uuid, 'REFUSED')">Refuse</b-dropdown-item>
                    </b-dropdown>
                  </template>
                </b-table>
              </b-card>
            </template>
          </b-table>
        </b-col>
      </b-row>
    </b-container>
  </div>
</template>

<script>
import { mapGetters } from "vuex";
import Navbar from "./Navbar.vue";
export default {
  name: "ManagerDashboard",
  components: {
    Navbar
  },
  computed: {
    ...mapGetters("users", {
      users: "users"
    })
  },
  data() {
    return {
      infoModal: {
        id: "info-modal",
        title: "",
        content: ""
      },
      sortBy: "start_date",
      sortDesc: false,
      new_manager_uuid: null,
      start_date: null,
      users_to_select: [],
      end_date: null,
      selected_user: null,
      is_show_inputs: false,
      toggleDetails: false,
      leave_fields: [
        {
          key: "start_date",
          sortable: true,
          formatter: value => {
            return value.split("T")[0];
          }
        },
        {
          key: "end_date",
          sortable: true,
          formatter: value => {
            return value.split("T")[0];
          }
        },
        { key: "days", sortable: true, label: "Work days", formatter: (value) => {
              return value/8
            } },
        { key: "status", sortable: true },
        { key: "actions", label: "Actions" }
      ],
      fields: [
        { key: "email", sortable: true },
        { key: "actions", label: "Actions" }
      ]
    };
  },
  mounted: function() {
    console.log(this.leaves);
    this.$store.commit("login/tryToLoadToken");
    this.$store.dispatch("users/getUsers");
  },
  methods: {
    set_as_manager() {
      let body = { manager_uuid: this.new_manager_uuid };
      let uuid = this.selected_user;
      let data = {
        uuid,
        body
      };
      this.$store.dispatch("users/updateUser", data);
    },

    update_leave(uuid, status) {
      let body = { status: status };
      let data = {
        uuid,
        body
      };
      this.$store.dispatch("leaves/updateLeaveAndUsers", data);
    },

    make_manager(uuid) {
      var i = 0;
      var users = [];
      this.new_manager_uuid = uuid;
      for (i = 0; i < this.users.length; i++) {
        if (this.users[i].uuid == uuid) {
          continue;
        }
        users.push({ value: this.users[i].uuid, text: this.users[i].email });
      }
      this.users_to_select = users;

      this.$root.$emit("bv::show::modal", this.infoModal.id);
    }
  }
};
</script>

<style>
</style>
